#if !defined(NAPA_OEM_H)
#define NAPA_OEM_H

/* This file defines some global definitions that may be changed by different OEMs */

#define DEFAULT_JBOD_DISKS_BITMAP	0xff	/* all JBOD ports by default */

/* DEFAULT_REBUILD_POLICY flags */
#define ENG_REBUILD_POLICY_REBUILD_FREE	0x01

#define DEFAULT_REBUILD_POLICY		0
#define DEFAULT_SYNC_POLICY			0
#define DEFAULT_INIT_POLICY			0
#define DEFAULT_MIGRATION_POLICY	0
#define DEFAULT_PATROL_POLICY		0

#define DEFAULT_REBUILD_RATE		10
#define DEFAULT_SYNC_RATE			10
#define DEFAULT_INIT_RATE			10
#define DEFAULT_MIGRATION_RATE		10
#define DEFAULT_PATROL_RATE			10

#define DEFAULT_SMARTCHECK_RATE		10		/* every 10 seconds */
#define DEFAULT_ENC_CHECK_RATE		10		/* every 10 seconds */

#define DEFAULT_SMART_CHECKING_ENABLE	0	/* disabled by default */
#define DEFAULT_AUTO_REBUILD_ENABLE		1	/* enabled by default */

#define DEFAULT_DRIVER_CACHE_MODE		1	/* 0: W/B, 1: W/T, 2: Bypass 3: auto*/
#define DEFAULT_DRIVER_LOOKAHEAD		4	/* larger value sacrifice more CPU utilization, 
											 * especially for small block sequential read. 4
											 * is moderate for both small and large block access. */
#define DEFAULT_DISK_CACHE_ENABLE		1	/* enable by default */
#define DEFAULT_DISK_LOOKAHEAD_ENABLE	1	/* enable by default */
#define DEFAULT_DRIVER_CONSOLIDATION	0

#define REQ_MAX_RETRY_COUNT		20
#define TASK_MAX_RETRY_COUNT	2

#define CC_MAXIMUM_LOOKAHEAD	8

#define ENGINE_PATROL_TASK_THRESHOLD	200	/* TBD, its value decide system overall performance when patrol is running */

#define CAM_Q_ERROR_THRESHOLD			16	/* queue will be disable if queue error threshold is exceeded */

#define INCLUDE_PCI_MEM_EVENT              /*NEC requirement*/

#if defined(_NEC)
#undef DEFAULT_REBUILD_POLICY
#define DEFAULT_REBUILD_POLICY			(ENG_REBUILD_POLICY_REBUILD_FREE)
#undef DEFAULT_DISK_CACHE_ENABLE			
#define DEFAULT_DISK_CACHE_ENABLE		0	/* disable by default */
#undef DEFAULT_REBUILD_RATE		
#define DEFAULT_REBUILD_RATE		    15
#undef DEFAULT_SYNC_RATE			
#define DEFAULT_SYNC_RATE			    15
#undef DEFAULT_INIT_RATE			
#define DEFAULT_INIT_RATE			    15
#undef DEFAULT_MIGRATION_RATE		
#define DEFAULT_MIGRATION_RATE		    15
#undef DEFAULT_PATROL_RATE			
#define DEFAULT_PATROL_RATE			    31
#undef DEFAULT_SMART_CHECKING_ENABLE	
#define DEFAULT_SMART_CHECKING_ENABLE	1	/* disabled by default */
#undef DEFAULT_SMARTCHECK_RATE		
#define DEFAULT_SMARTCHECK_RATE		    120 	/* every 120 seconds */
#undef DEFAULT_DRIVER_CACHE_MODE		
#define DEFAULT_DRIVER_CACHE_MODE		3	/* 0: W/B, 1: W/T, 2: Bypass 3: auto*/
#undef SUPPORT_SAFTE

#define PRESERVE_MARK_DOWN_EXTENT_FLAG

#endif	/*_NEC*/

#endif
