/****************************************************************
 *						Handle OS Request						*
 ****************************************************************/
#include "stdafx.h"

NEEDCOMPLETE
scsiInquiry(
	IN PVOID OSExt,
	IN PSCSI_REQUEST_BLOCK Srb
);

NEEDCOMPLETE
scsiGetControllerInfor(
	IN PVOID OSExt,
	IN PSCSI_REQUEST_BLOCK Srb
);

NEEDCOMPLETE
scsiFlashCommand(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
);

NEEDCOMPLETE
OSD_HandleSCSIRequest(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
	)
{
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)OSDExt;
	bpMU_COMP_EXTENSION pMUExtension = 
		(bpMU_COMP_EXTENSION)CMPM_GetComponentExtension(pOSDExtension, COMP_TYPE_MU);
	NEEDCOMPLETE NeedComplete;

	/* OSD Handles the console inquiry request. */
	if ( Srb->TargetId==MAX_ARRAY_SUPPORTED && Srb->Lun==0 && Srb->Cdb[0]==scsiINQUIRY )
	{
		return scsiInquiry(pOSDExtension, Srb);
	}

#if 0
	/* Request: Dump Controller Information */
	if ( Srb->Cdb[0]==svucPASSTHROUGH_API_COMMAND &&
		Srb->Cdb[1]==ocmdGetAdapter )
	{
		return scsiGetControllerInfor(pOSDExtension, Srb);
	}
#endif

#ifdef SUPPORT_IMAGE_FLASH
	/* Flash Image Request */
	if ( Srb->Cdb[0]==svucPASSTHROUGH_API_COMMAND &&
		Srb->Cdb[1]==ocmdFlash )
	{
		return scsiFlashCommand(pOSDExtension, Srb);
	}
#endif

	/* Request Left for MU */
	NeedComplete = MU_HandleRequest(pMUExtension,Srb);

	return NeedComplete;
}


STATIC U8 bConsoleInquiryPage[64] = 
{
	0x03,0x00,0x03,0x03,0xFA,0x00,0x00,0x30,
	0x50,0x72,0x6F,0x6D,0x69,0x73,0x65,0x20,	/* "Promise " */
	0x52,0x41,0x49,0x44,0x20,0x43,0x6F,0x6E,	/* "Raid Con" */
	0x73,0x6F,0x6C,0x65,0x20,0x20,0x20,0x20,	/* "sole    " */
	0x31,0x2E,0x30,0x30,0x20,0x20,0x20,0x20,	/* "1.00    " */
	0x53,0x58,0x2F,0x52,0x53,0x41,0x46,0x2D,	/* "SX/RSAF-" */
	0x54,0x45,0x31,0x2E,0x30,0x30,0x20,0x20,	/* "TE1.00  " */
	0x0C,0x20,0x20,0x20,0x20,0x20,0x20,0x20
};


NEEDCOMPLETE
scsiInquiry(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
)
{
	OSD_DASSERT( Srb->Cdb[0]==scsiINQUIRY 
		&& Srb->TargetId==MAX_ARRAY_SUPPORTED && Srb->Lun==0 );

	gen_memmove(
		(void *)Srb->DataBuffer, 
		(void *)bConsoleInquiryPage,
		Min(Srb->Cdb[4], sizeof(bConsoleInquiryPage))
		);

	Srb->SrbStatus = SRB_STATUS_SUCCESS;

	return TRUE;
}

NEEDCOMPLETE
scsiGetControllerInfor(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
)
{
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)OSDExt;
	PHOST_CONTROLLER_INFO pController = &pOSDExtension->ControllerInfo;
	PAPIFRAME_ADAPTER_INFORMATION pReq = 
		(PAPIFRAME_ADAPTER_INFORMATION)Srb->DataBuffer;
	U8 i;
	for ( i=0; i<BASE_ADDRESS_MAX_NUM; i++ )
		pReq->BaseAddress[i] = (U32)(PTR_SIZE)pOSDExtension->BaseAddress[i];
	pReq->ExpansionROMAddress = 0;

	pReq->DriverVersion.VerMajor = VER_MAJOR;
	pReq->DriverVersion.VerMinor = VER_MINOR;
	pReq->DriverVersion.VerOEM = OEM;
	pReq->DriverVersion.VerBuild = BUILD_VER;

	pReq->SystemIoBusNumber = pController->SystemIoBusNumber;
	pReq->SlotNumber = pController->SlotNumber;
	pReq->InterruptLevel = pController->InterruptLevel;
	pReq->InterruptVector = pController->InterruptVector;
	pReq->VenDevID = pController->DeviceID;
	pReq->SubVenDevID = pController->SubDeviceID;

    /* The following values are set by firmware. So don't touch. 
		pReq->DIMMSize = 512;
		pReq->DIMMType = DIMM_TYPE_ECC;
		pReq->ChannelNumber = 8;
		pReq->BIOSVersion.VerMajor = 0;
		pReq->BIOSVersion.VerMinor = 0;
		pReq->BIOSVersion.VerOEM = 0;
		pReq->BIOSVersion.VerBuild = 0;
	*/

	Srb->SrbStatus = SRB_STATUS_SUCCESS;

	return TRUE;
}
#ifdef _WINDRIVER
#ifndef USE_STORPORT
/********************************************************************
 *						Handle IO Control Request					*
 ********************************************************************/
#define IOCTL_CHECK_BUFFER_SIZE(srb,length)									\
	if( ((SRB_IO_CONTROL *)(Srb->DataBuffer))->Length<length )				\
	{																		\
		OSD_TRACE(("Invalid parameter buffer length (IOCTL: %x) %x<%x\n",	\
			((SRB_IO_CONTROL *)(Srb->DataBuffer))->ControlCode,				\
			((SRB_IO_CONTROL *)(Srb->DataBuffer))->Length,					\
			length ));														\
		Srb->SrbStatus = SRB_STATUS_ERROR;									\
		break;																\
	}

NEEDCOMPLETE
OSDI_SystemPowerStateChanging(
	IN bpOSD_COMP_EXTENSION pOSDExtension,
	IN PSCSI_REQUEST_BLOCK Srb,
	IN ULONG State
	)
{
	bpMU_COMP_EXTENSION pMUExtension = 
		(bpMU_COMP_EXTENSION)CMPM_GetComponentExtension(pOSDExtension, COMP_TYPE_MU);

	OSD_TRACE( ("System is going to %s S0\n", State ? "re-enter" : "leave") );

	Srb->Function = SRB_FUNCTION_EXECUTE_SCSI;

	/* POWER CHANGE SRB do more than STOP ALL BGA. Don't call STOP_ALL_BGA. */
	#if 0
	Srb->Cdb[0] = 0xe1;			/*svucCONTROLLER_COMMAND*/
	Srb->Cdb[1] = 0;			/*ccmdSTOP_ALL_BGA*/
	Srb->Cdb[2] = 0x06;			/*MT_ACT_AUTOPAUSE*/
	#else
	Srb->Cdb[0] = 0xe1;			/*svucCONTROLLER_COMMAND*/
	Srb->Cdb[1] = 0x0e;			/*ccmdPOWER_STATE_CHANGING*/
	Srb->Cdb[2] = State? 0 : 1;	/*CCMD_POWER_WORKING : CCMD_POWER_SAVING*/
	#endif

	return MU_HandleRequest(pMUExtension,Srb);
}

NEEDCOMPLETE
OSD_HandleIOControl(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
)
{
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)OSDExt;
	bpMU_COMP_EXTENSION pMUExtension = 
		(bpMU_COMP_EXTENSION)CMPM_GetComponentExtension(pOSDExtension, COMP_TYPE_MU);

	SRB_IO_CONTROL * pIOCTL;

	Srb->SrbStatus=SRB_STATUS_INVALID_REQUEST;
	pIOCTL = (SRB_IO_CONTROL *)(Srb->DataBuffer);

	/* Signature of the SRB_IO_CONTROL is wrong. Return immediately. */
	if(	(*((U32 *)&(pIOCTL->Signature))!=FASTTRAK_IOCTL_SIGNATURE1) ||
		(*(((U32 *)&(pIOCTL->Signature))+1)!=FASTTRAK_IOCTL_SIGNATURE2)
	  )
	  return TRUE;

	/* Handle IOCTL Request */
    Srb->SrbStatus = SRB_STATUS_SUCCESS;

	switch (pIOCTL->ControlCode)
	{
		case IOCTL_FASTTRAK_GETVERSION:
			IOCTL_CHECK_BUFFER_SIZE( Srb, sizeof(IOCTL_DRIVERVERSION_FRAME) );
		{
			PIOCTL_DRIVERVERSION_FRAME pVersion = 
				(PIOCTL_DRIVERVERSION_FRAME)((SRB_IO_CONTROL *)(Srb->DataBuffer)+1);
			pVersion->Major = VER_MAJOR;
			pVersion->Minor = VER_MINOR;
			pVersion->Oem = OEM;
			pVersion->BuildNo = BUILD_VER;
			pVersion->Signature[0] = 'NAPA';
			pVersion->ConsoleID = CONSOLEDEVICE_TARGETID;
			break;
		}

		case IOCTL_FASTTRAK_POWER_STATE_CHANGING:
		{
			return OSDI_SystemPowerStateChanging(
				pOSDExtension,
				Srb,
				*(PULONG)((SRB_IO_CONTROL *)(Srb->DataBuffer)+1)
				);
		}

		default:
			Srb->SrbStatus = SRB_STATUS_INVALID_REQUEST;
			break;
	}

	return TRUE;
}
#endif /* USE_STORPORT */
#endif
NEEDCOMPLETE
OSD_HandleConsoleRequest(
	IN PVOID OSDExtension,
	IN PSCSI_REQUEST_BLOCK Srb
)
{
	Srb->SrbStatus=SRB_STATUS_INVALID_REQUEST;
	return TRUE;
}

#ifdef SUPPORT_IMAGE_FLASH
NEEDCOMPLETE
Flash_UploadImage(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
)
{
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)OSDExt;
	bpMU_COMP_EXTENSION pMUExtension = 
		(bpMU_COMP_EXTENSION)CMPM_GetComponentExtension(pOSDExtension, COMP_TYPE_MU);
	
	bpCDB_FLASH pFlashCdb = (bpCDB_FLASH)Srb->Cdb;
	/* Sanity check: only one transaction is going on. 
	 * OriginalSrb is only used to indicate that one transaction is going on. */
	if ( pFlashCdb->PageNumber==0 && pOSDExtension->OriginalSrb!=NULL )
	{
		Srb->SrbStatus = SRB_STATUS_ERROR;
		return TRUE;
	}
	pOSDExtension->OriginalSrb = Srb;

	/* Firmware DMA the data from the utility data buffer to the local DIMM.
	 * MU_HandleRequest will transfer the SG table. */
	return MU_HandleRequest(pMUExtension, Srb);
}


NEEDCOMPLETE
Flash_DownloadImage(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
)
{
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)OSDExt;
	bpMU_COMP_EXTENSION pMUExtension = 
		(bpMU_COMP_EXTENSION)CMPM_GetComponentExtension(pOSDExtension, COMP_TYPE_MU);

	/* Make sure there is no upload going on. */
	if ( pOSDExtension->OriginalSrb!=NULL )
	{
		Srb->SrbStatus = SRB_STATUS_ERROR;
		return TRUE;
	}

	/* MU_HandleRequest will transfer the SG table. */
	return MU_HandleRequest(pMUExtension, Srb);
}

NEEDCOMPLETE
scsiFlashCommand(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
)
{
	OSD_DASSERT( (Srb->Cdb[0]==svucPASSTHROUGH_API_COMMAND) && (Srb->Cdb[1]==ocmdFlash) );

	switch ( Srb->Cdb[2] )
	{
		case FLASH_CONTROL_UPLOADIMAGE:
			return Flash_UploadImage(OSDExt, Srb);
		case FLASH_CONTROL_DOWNLOADIMAGE:
			return Flash_DownloadImage(OSDExt, Srb);
		default:
			Srb->SrbStatus = SRB_STATUS_ERROR;
			return TRUE;
	}
}

#endif

/********************************************************************
 *						Request Return								*
 ********************************************************************/
PSCSI_REQUEST_BLOCK 
OSD_InternalRAIDReturn(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
	)
{
#ifdef SUPPORT_IMAGE_FLASH
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)OSDExt;
    bpCDB_FLASH pFlashCdb = NULL;

	/* Whether upload transaction is done. */
	if ( (Srb->Cdb[0]==svucPASSTHROUGH_API_COMMAND)
		&& (Srb->Cdb[1]==ocmdFlash) )
	{
		pFlashCdb = (bpCDB_FLASH)Srb->Cdb;
		if ( 
			( (pFlashCdb->FlashCommand==FLASH_CONTROL_UPLOADIMAGE) 
				&& (pFlashCdb->PageFlag&FLASH_FLAG_LAST_PAGE) ) 
			|| ( Srb->SrbStatus!=SRB_STATUS_SUCCESS )
			|| ( Srb->ScsiStatus!=ssGOOD )
			)
			pOSDExtension->OriginalSrb = NULL;
	}	
#endif /* SUPPORT_IMAGE_FLASH */

	return Srb;
}

void OSD_RAIDReturn(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
	)
{
	/* OSD may need do something before returning this request. */
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)OSDExt;
	PSCSI_REQUEST_BLOCK OS_Srb;

	/* 
	 * Let's check whether it's our internal request. 
	 */
	OS_Srb = OSD_InternalRAIDReturn(OSDExt, Srb);
	if ( OS_Srb==NULL ) return;

	/* 
	 * Some post operation. 
	 */
	/* Request: Dump Controller Information: It's handled by both firmware and driver. */
	if ( Srb->Cdb[0]==svucPASSTHROUGH_API_COMMAND &&
		Srb->Cdb[1]==ocmdGetAdapter )
	{
		scsiGetControllerInfor(pOSDExtension, Srb);
	}

	/* 
	 * Return the Srb to the operating system. 
	 */
	#if defined(_LINUXDRIVER)
	OSD_TrueRAIDReturn(OSDExt, OS_Srb);
	#else
	CompleteAndAskForNextReq(pOSDExtension->DeviceExtension, OS_Srb, TRUE, TRUE);
	#endif
	if ( pOSDExtension->State==SYS_STATE_SHUTINGDOWN )
		pOSDExtension->State=SYS_STATE_SHUTDOWN;
}

#if defined(_LINUXDRIVER)
NEEDCOMPLETE
OSD_HandleShutdown(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
	)
{
	return FALSE;/*release_single_device()*/
}
#else
NEEDCOMPLETE
OSD_HandleShutdown(
	IN PVOID OSDExt,
	IN PSCSI_REQUEST_BLOCK Srb
	)
{
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)OSDExt;
	bpMU_COMP_EXTENSION pMUExtension = 
		(bpMU_COMP_EXTENSION)CMPM_GetComponentExtension(pOSDExtension, COMP_TYPE_MU);

	Srb->Function = SRB_FUNCTION_EXECUTE_SCSI;
	Srb->CdbLength = 6;
	Srb->SrbStatus = SRB_STATUS_PENDING;

	Srb->Cdb[0] = scsiSYNCHRONIZE_CACHE;

	return MU_HandleRequest(pMUExtension,Srb);
}
#endif
